var RiveScript = require('rivescript');

var _internals = {};

_internals.error_handler = function (loadcount, err) {
	console.log("Error loading batch #" + loadcount + ": " + err + "\n");
};

_internals.getReply = function (payload, cb) {
	
    var bot = _internals.bot;
    
	// Get a reply from the bot.
	var reply = bot.reply(payload.username, payload.message, this);

	// Get all the user's vars back out of the bot to include in the response.
	vars = bot.getUservars(payload.username);
    
    cb({
		"status": "ok",
		"reply": reply,
		"vars": vars
	});
};

module.exports = function(RED) {
    'use strict';

    function Node(n) {
      
        RED.nodes.createNode(this,n);

        var node = this;
        
        this.on('input', function (msg) {
            
            _internals.bot = new RiveScript();
            _internals.bot.stream(msg.script, _internals.error_handler);
            _internals.bot.sortReplies();
            
            var payload = typeof msg.payload === 'object' ? msg.payload : {};
        
            var attrs = ['tweet'];
            for (var attr of attrs) {
                if (n[attr]) {
                    payload[attr] = n[attr];     
                }
            }
            
            if (payload.vars) {
                
                _internals.bot.setUservars(payload.username, payload.vars);
            }
            
            payload.id = payload.tweet;

            _internals.getReply(payload, function(result){
        
                msg.payload = result;
                node.send(msg);
            
                _internals.bot = null;
            });
        });
    }

    RED.nodes.registerType('rivescript-reply', Node);
};
